Index: /pjproject/main/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_transaction.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_transaction.c	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_transaction.h>
@@ -8,4 +7,5 @@
 #include <pjsip/sip_event.h>
 #include <pjsip/sip_endpoint.h>
+#include <pjsip/sip_errno.h>
 #include <pj/log.h>
 #include <pj/string.h>
@@ -13,7 +13,8 @@
 #include <pj/guid.h>
 #include <pj/pool.h>
+#include <pj/assert.h>
 
 /* Thread Local Storage ID for transaction lock (initialized by endpoint) */
-int pjsip_tsx_lock_tls_id;
+long pjsip_tsx_lock_tls_id;
 
 /* State names */
@@ -44,8 +45,12 @@
 } tsx_lock_data;
 
+
 /* Timer timeout value constants */
-static const pj_time_val t1_timer_val = { PJSIP_T1_TIMEOUT/1000, PJSIP_T1_TIMEOUT%1000 };
-static const pj_time_val t4_timer_val = { PJSIP_T4_TIMEOUT/1000, PJSIP_T4_TIMEOUT%1000 };
-static const pj_time_val td_timer_val = { PJSIP_TD_TIMEOUT/1000, PJSIP_TD_TIMEOUT%1000 };
+static const pj_time_val t1_timer_val = { PJSIP_T1_TIMEOUT/1000, 
+                                          PJSIP_T1_TIMEOUT%1000 };
+static const pj_time_val t4_timer_val = { PJSIP_T4_TIMEOUT/1000, 
+                                          PJSIP_T4_TIMEOUT%1000 };
+static const pj_time_val td_timer_val = { PJSIP_TD_TIMEOUT/1000, 
+                                          PJSIP_TD_TIMEOUT%1000 };
 static const pj_time_val timeout_timer_val = { (64*PJSIP_T1_TIMEOUT)/1000,
 					       (64*PJSIP_T1_TIMEOUT)%1000 };
@@ -59,33 +64,37 @@
 
 /* Function Prototypes */
-static int  pjsip_tsx_on_state_null( pjsip_transaction *tsx, 
-				     pjsip_event *event);
-static int  pjsip_tsx_on_state_calling( pjsip_transaction *tsx, 
-				        pjsip_event *event);
-static int  pjsip_tsx_on_state_trying( pjsip_transaction *tsx, 
-				       pjsip_event *event);
-static int  pjsip_tsx_on_state_proceeding_uas( pjsip_transaction *tsx, 
-					       pjsip_event *event);
-static int  pjsip_tsx_on_state_proceeding_uac( pjsip_transaction *tsx, 
-					       pjsip_event *event);
-static int  pjsip_tsx_on_state_completed_uas( pjsip_transaction *tsx, 
-					      pjsip_event *event);
-static int  pjsip_tsx_on_state_completed_uac( pjsip_transaction *tsx, 
-					      pjsip_event *event);
-static int  pjsip_tsx_on_state_confirmed( pjsip_transaction *tsx, 
-					  pjsip_event *event);
-static int  pjsip_tsx_on_state_terminated( pjsip_transaction *tsx, 
-					   pjsip_event *event);
-static int  pjsip_tsx_on_state_destroyed( pjsip_transaction *tsx, 
-					  pjsip_event *event);
-static void tsx_timer_callback( pj_timer_heap_t *theap, 
-			        pj_timer_entry *entry);
-static int  tsx_send_msg( pjsip_transaction *tsx, pjsip_tx_data *tdata);
-static void lock_tsx( pjsip_transaction *tsx, struct tsx_lock_data *lck );
-static pj_status_t unlock_tsx( pjsip_transaction *tsx, struct tsx_lock_data *lck );
+static pj_status_t pjsip_tsx_on_state_null(     pjsip_transaction *tsx, 
+				                pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_calling(  pjsip_transaction *tsx, 
+				                pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_trying(   pjsip_transaction *tsx, 
+				                pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_proceeding_uas( pjsip_transaction *tsx, 
+					        pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_proceeding_uac( pjsip_transaction *tsx,
+					        pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_completed_uas( pjsip_transaction *tsx, 
+					        pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_completed_uac( pjsip_transaction *tsx,
+					        pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_confirmed(pjsip_transaction *tsx, 
+					        pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_terminated(pjsip_transaction *tsx, 
+					        pjsip_event *event);
+static pj_status_t pjsip_tsx_on_state_destroyed(pjsip_transaction *tsx, 
+					        pjsip_event *event);
+
+static void         tsx_timer_callback( pj_timer_heap_t *theap, 
+			                pj_timer_entry *entry);
+static int          tsx_send_msg( pjsip_transaction *tsx, 
+                                  pjsip_tx_data *tdata);
+static void         lock_tsx( pjsip_transaction *tsx, struct 
+                               tsx_lock_data *lck );
+static pj_status_t  unlock_tsx( pjsip_transaction *tsx, 
+                               struct tsx_lock_data *lck );
 
 /* State handlers for UAC, indexed by state */
-static int  (*tsx_state_handler_uac[PJSIP_TSX_STATE_MAX])(pjsip_transaction *tsx,
-							  pjsip_event *event ) = 
+static int  (*tsx_state_handler_uac[PJSIP_TSX_STATE_MAX])(pjsip_transaction *,
+							  pjsip_event *) = 
 {
     &pjsip_tsx_on_state_null,
@@ -100,6 +109,6 @@
 
 /* State handlers for UAS */
-static int  (*tsx_state_handler_uas[PJSIP_TSX_STATE_MAX])(pjsip_transaction *tsx, 
-							  pjsip_event *event ) = 
+static int  (*tsx_state_handler_uas[PJSIP_TSX_STATE_MAX])(pjsip_transaction *, 
+							  pjsip_event *) = 
 {
     &pjsip_tsx_on_state_null,
@@ -154,9 +163,9 @@
  * components. Additional comparison is needed to fully match a transaction.
  */
-void create_tsx_key_2543( pj_pool_t *pool,
-			  pj_str_t *str,
-			  pjsip_role_e role,
-			  const pjsip_method *method,
-			  const pjsip_rx_data *rdata )
+static pj_status_t create_tsx_key_2543( pj_pool_t *pool,
+			                pj_str_t *str,
+			                pjsip_role_e role,
+			                const pjsip_method *method,
+			                const pjsip_rx_data *rdata )
 {
 #define SEPARATOR   '$'
@@ -167,15 +176,20 @@
     pj_str_t *host;
 
+    PJ_ASSERT_RETURN(pool && str && method && rdata, PJ_EINVAL);
+    PJ_ASSERT_RETURN(rdata->msg, PJ_EINVAL);
+    PJ_ASSERT_RETURN(rdata->via, PJSIP_EMISSINGHDR);
+    PJ_ASSERT_RETURN(rdata->cseq, PJSIP_EMISSINGHDR);
+    PJ_ASSERT_RETURN(rdata->from, PJSIP_EMISSINGHDR);
+
     host = &rdata->via->sent_by.host;
     req_uri = (pjsip_uri*)rdata->msg->line.req.uri;
 
     /* Calculate length required. */
-    len_required = PJSIP_MAX_URL_SIZE +	    /* URI */
-		   9 +			    /* CSeq number */
-		   rdata->from_tag.slen +   /* From tag. */
+    len_required = 9 +			    /* CSeq number */
+		   rdata->from->tag.slen +   /* From tag. */
 		   rdata->call_id.slen +    /* Call-ID */
 		   host->slen +		    /* Via host. */
 		   9 +			    /* Via port. */
-		   32;			    /* Separator+Allowance. */
+		   16;			    /* Separator+Allowance. */
     key = p = pj_pool_alloc(pool, len_required);
     end = p + len_required;
@@ -224,7 +238,4 @@
      * request retransmissions will contain the same port.
      */
-    if ((end-p) < host->slen + 12) {
-	goto on_error;
-    }
     pj_memcpy(p, host->ptr, host->slen);
     p += host->slen;
@@ -241,12 +252,5 @@
     str->slen = p-key;
 
-    return;
-
-on_error:
-    PJ_LOG(2,("tsx........", "Not enough buffer (%d) for transaction key",
-	      len_required));
-    pj_assert(0);
-    str->ptr = NULL;
-    str->slen = 0;
+    return PJ_SUCCESS;
 }
 
@@ -254,11 +258,13 @@
  * Create transaction key for RFC3161 compliant system.
  */
-void create_tsx_key_3261( pj_pool_t *pool,
-			  pj_str_t *key,
-			  pjsip_role_e role,
-			  const pjsip_method *method,
-			  const pj_str_t *branch )
+static pj_status_t create_tsx_key_3261( pj_pool_t *pool,
+		                        pj_str_t *key,
+		                        pjsip_role_e role,
+		                        const pjsip_method *method,
+		                        const pj_str_t *branch)
 {
     char *p;
+
+    PJ_ASSERT_RETURN(pool && key && method && branch, PJ_EINVAL);
 
     p = key->ptr = pj_pool_alloc(pool, branch->slen + method->name.slen + 4 );
@@ -281,4 +287,6 @@
     /* Set length */
     key->slen = p - key->ptr;
+
+    return PJ_SUCCESS;
 }
 
@@ -287,10 +295,12 @@
  * in the transaction hash table.
  */
-PJ_DEF(void) pjsip_tsx_create_key( pj_pool_t *pool, pj_str_t *key, 
-				   pjsip_role_e role, 
-				   const pjsip_method *method, 
-				   const pjsip_rx_data *rdata )
-{
-    pj_str_t rfc3261_branch = {PJSIP_RFC3261_BRANCH_ID, PJSIP_RFC3261_BRANCH_LEN};
+PJ_DEF(pj_status_t) pjsip_tsx_create_key( pj_pool_t *pool, pj_str_t *key, 
+				          pjsip_role_e role, 
+				          const pjsip_method *method, 
+				          const pjsip_rx_data *rdata)
+{
+    pj_str_t rfc3261_branch = {PJSIP_RFC3261_BRANCH_ID, 
+                               PJSIP_RFC3261_BRANCH_LEN};
+
 
     /* Get the branch parameter in the top-most Via.
@@ -301,15 +311,16 @@
     const pj_str_t *branch = &rdata->via->branch_param;
 
-    if (pj_strncmp(branch, &rfc3261_branch, PJSIP_RFC3261_BRANCH_LEN) == 0) {
+    if (pj_strncmp(branch,&rfc3261_branch,PJSIP_RFC3261_BRANCH_LEN)==0) {
 
 	/* Create transaction key. */
-	create_tsx_key_3261(pool, key, role, method, branch);
+	return create_tsx_key_3261(pool, key, role, method, branch);
 
     } else {
-	/* Create the key for the message. This key will be matched up with the
-	 * transaction key. For RFC2563 transactions, the transaction key
-	 * was created by the same function, so it will match the message.
+	/* Create the key for the message. This key will be matched up 
+         * with the transaction key. For RFC2563 transactions, the 
+         * transaction key was created by the same function, so it will 
+         * match the message.
 	 */
-	create_tsx_key_2543( pool, key, role, method, rdata );
+	return create_tsx_key_2543( pool, key, role, method, rdata );
     }
 }
@@ -319,8 +330,10 @@
  * Create new transaction.
  */
-PJ_DEF(pjsip_transaction *) pjsip_tsx_create(pj_pool_t *pool,
-					     pjsip_endpoint *endpt)
+pj_status_t pjsip_tsx_create( pj_pool_t *pool,
+			      pjsip_endpoint *endpt,
+                              pjsip_transaction **p_tsx)
 {
     pjsip_transaction *tsx;
+    pj_status_t status;
 
     tsx = pj_pool_calloc(pool, 1, sizeof(pjsip_transaction));
@@ -336,11 +349,12 @@
     tsx->timeout_timer.user_data = tsx;
     tsx->timeout_timer.cb = &tsx_timer_callback;
-    sprintf(tsx->obj_name, "tsx%p", tsx);
-    tsx->mutex = pj_mutex_create(pool, "mtsx%p", 0);
-    if (!tsx->mutex) {
-	return NULL;
-    }
-
-    return tsx;
+    pj_sprintf(tsx->obj_name, "tsx%p", tsx);
+    status = pj_mutex_create_recursive(pool, "mtsx%p", &tsx->mutex);
+    if (status != PJ_SUCCESS) {
+	return status;
+    }
+
+    *p_tsx = tsx;
+    return PJ_SUCCESS;
 }
 
@@ -353,5 +367,6 @@
 
     pj_mutex_lock(tsx->mutex);
-    prev_data = (struct tsx_lock_data *) pj_thread_local_get(pjsip_tsx_lock_tls_id);
+    prev_data = (struct tsx_lock_data *) 
+                    pj_thread_local_get(pjsip_tsx_lock_tls_id);
     lck->prev = prev_data;
     lck->tsx = tsx;
@@ -368,5 +383,6 @@
  * will be set to zero.
  */
-static pj_status_t unlock_tsx(pjsip_transaction *tsx, struct tsx_lock_data *lck)
+static pj_status_t unlock_tsx( pjsip_transaction *tsx, 
+                               struct tsx_lock_data *lck)
 {
     pj_assert( (void*)pj_thread_local_get(pjsip_tsx_lock_tls_id) == lck);
@@ -376,5 +392,5 @@
 	pj_mutex_unlock(tsx->mutex);
 
-    return lck->is_alive ? 0 : -1;
+    return lck->is_alive ? PJ_SUCCESS : PJSIP_ETSXDESTROYED;
 }
 
@@ -384,11 +400,12 @@
 static void tsx_set_state( pjsip_transaction *tsx,
 			   pjsip_tsx_state_e state,
-			   const pjsip_event *event )
+			   pjsip_event_id_e event_src_type,
+                           void *event_src )
 {
     pjsip_event e;
 
-    PJ_LOG(4, (tsx->obj_name, "STATE %s-->%s, ev=%s (src:%s)", 
-	       state_str[tsx->state], state_str[state], pjsip_event_str(event->type),
-	       pjsip_event_str(event->src_type)));
+    PJ_LOG(4, (tsx->obj_name, "STATE %s-->%s, cause = %s",
+	       state_str[tsx->state], state_str[state], 
+               pjsip_event_str(event_src_type)));
 
     /* Change state. */
@@ -403,7 +420,5 @@
 
     /* Inform TU */
-    pj_memcpy(&e, event, sizeof(*event));
-    e.type = PJSIP_EVENT_TSX_STATE_CHANGED;
-    e.obj.tsx = tsx;
+    PJSIP_EVENT_INIT_TSX_STATE(e, tsx, event_src_type, event_src);
     pjsip_endpt_send_tsx_event( tsx->endpt, &e  );
 
@@ -414,5 +429,7 @@
 
 	/* Decrement transport reference counter. */
-	if (tsx->transport && tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL) {
+	if (tsx->transport && 
+            tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL) 
+        {
 	    pjsip_transport_dec_ref( tsx->transport );
 	    tsx->transport = NULL;
@@ -484,5 +501,6 @@
 	while (last_route_hdr->next != (void*)&tdata->msg->hdr) {
 	    pjsip_route_hdr *hdr;
-	    hdr = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, last_route_hdr->next);
+	    hdr = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_ROUTE, 
+                                     last_route_hdr->next);
 	    if (!hdr)
 		break;
@@ -564,5 +582,6 @@
 	pj_strdup(tdata->pool, &send_addr->host, &url->host);
         send_addr->port = url->port;
-	send_addr->type = pjsip_transport_get_type_from_name(&url->transport_param);
+	send_addr->type = 
+            pjsip_transport_get_type_from_name(&url->transport_param);
 
     } else if (PJSIP_URI_SCHEME_IS_SIP(target_uri)) {
@@ -571,5 +590,6 @@
 	pj_strdup(tdata->pool, &send_addr->host, &url->host);
 	send_addr->port = url->port;
-	send_addr->type = pjsip_transport_get_type_from_name(&url->transport_param);
+	send_addr->type = 
+            pjsip_transport_get_type_from_name(&url->transport_param);
 #if PJ_HAS_TCP
 	if (send_addr->type == PJSIP_TRANSPORT_TCP || 
@@ -580,7 +600,6 @@
 #endif
     } else {
-	PJ_LOG(2, (tsx->obj_name, "Unable to lookup destination address for "
-				  "non SIP-URL"));   
-	return -1;
+        pj_assert(!"Unsupported URI scheme!");
+	return PJSIP_EINVALIDSCHEME;
     }
 
@@ -599,5 +618,5 @@
 
     /* Success. */
-    return 0;  
+    return PJ_SUCCESS;  
 }
 
@@ -625,5 +644,5 @@
 				  addr, tsx->dest_name.port));
     } else {
-	PJ_LOG(3, (tsx->obj_name, "%s unable to connect to %s:%d, status=%d", 
+	PJ_LOG(4, (tsx->obj_name, "%s unable to connect to %s:%d, status=%d", 
 				  pjsip_transport_get_type_name(tr),
 				  addr, tsx->dest_name.port, status));
@@ -634,13 +653,9 @@
 
     if (status != PJ_SUCCESS) {
-	pjsip_event event;
-	
-	event.type = PJSIP_EVENT_TRANSPORT_ERROR;
-	event.src_type = PJSIP_EVENT_TX_MSG;
-	event.src.tdata = tsx->last_tx;
-
 	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
 	tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, &event);
+
+	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED,
+                      PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
 
 	/* Unlock transaction. */
@@ -649,6 +664,6 @@
     }
 
-    /* See if transaction has already been terminated. If so, schedule to destroy
-     * the transaction.
+    /* See if transaction has already been terminated. 
+     * If so, schedule to destroy the transaction.
      */
     if (tsx->state == PJSIP_TSX_STATE_TERMINATED) {
@@ -691,13 +706,8 @@
 
     if (status != PJ_SUCCESS || addr->count == 0) {
-	pjsip_event event;
-	
-	event.type = PJSIP_EVENT_TRANSPORT_ERROR;
-	event.src_type = PJSIP_EVENT_TX_MSG;
-	event.src.tdata = tsx->last_tx;
-
 	lock_tsx(tsx, &lck);
 	tsx->status_code = PJSIP_SC_TSX_RESOLVE_ERROR;
-	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, &event);
+	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, 
+                      PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
 	unlock_tsx(tsx, &lck);
 	return;
@@ -712,6 +722,6 @@
     /* Create/find the transport for the remote address. */
     PJ_LOG(5,(tsx->obj_name, "tsx getting transport for %s:%d",
-			     pj_sockaddr_get_str_addr(&addr->entry[0].addr),
-			     pj_sockaddr_get_port(&addr->entry[0].addr)));
+			     pj_inet_ntoa(addr->entry[0].addr.sin_addr),
+			     pj_ntohs(addr->entry[0].addr.sin_port)));
 
     tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_CONNECTING;
@@ -739,6 +749,6 @@
     pjsip_cseq_hdr *cseq;
     pjsip_via_hdr *via;
+    pj_status_t status;
     struct tsx_lock_data lck;
-    const pjsip_hdr *endpt_hdr;
 
     PJ_LOG(4,(tsx->obj_name, "initializing tsx as UAC (tdata=%p)", tdata));
@@ -756,5 +766,5 @@
     pjsip_method_copy( tsx->pool, &tsx->method, &msg->line.req.method);
 
-    /* Generate branch parameter if it doesn't exist. */
+    /* Generate Via header if it doesn't exist. */
     via = pjsip_msg_find_hdr(msg, PJSIP_H_VIA, NULL);
     if (via == NULL) {
@@ -772,21 +782,21 @@
 	tmp.ptr = via->branch_param.ptr + PJSIP_RFC3261_BRANCH_LEN;
 	pj_generate_unique_string( &tmp );
-    }
-
-    /* Copy branch parameter. */
-    tsx->branch = via->branch_param;
-
-    /* Add additional request headers from endpoint. */
-    endpt_hdr = pjsip_endpt_get_request_headers(tsx->endpt)->next;
-    while (endpt_hdr != pjsip_endpt_get_request_headers(tsx->endpt)) {
-	pjsip_hdr *hdr = pjsip_hdr_shallow_clone(tdata->pool, endpt_hdr);
-	pjsip_msg_add_hdr( tdata->msg, hdr );
-	endpt_hdr = endpt_hdr->next;
-    }
+
+        /* Save branch parameter. */
+        tsx->branch = via->branch_param;
+    } else {
+        /* Copy branch parameter. */
+        pj_strdup(tsx->pool, &tsx->branch, &via->branch_param);
+    }
+
 
     /* Generate transaction key. */
-    create_tsx_key_3261( tsx->pool, &tsx->transaction_key,
-			 PJSIP_ROLE_UAC, &tsx->method, 
-			 &via->branch_param);
+    status = create_tsx_key_3261( tsx->pool, &tsx->transaction_key,
+			          PJSIP_ROLE_UAC, &tsx->method, 
+			          &via->branch_param);
+    if (status != PJ_SUCCESS) {
+        unlock_tsx(tsx, &lck);
+        return status;
+    }
 
     PJ_LOG(6, (tsx->obj_name, "tsx_key=%.*s", tsx->transaction_key.slen,
@@ -796,6 +806,7 @@
     cseq = pjsip_msg_find_hdr(msg, PJSIP_H_CSEQ, NULL);
     if (!cseq) {
-	PJ_LOG(4,(tsx->obj_name, "CSeq header not present in outgoing message!"));
-	return -1;
+	pj_assert(!"CSeq header not present in outgoing message!");
+        unlock_tsx(tsx, &lck);
+	return PJSIP_EMISSINGHDR;
     }
     tsx->cseq = cseq->cseq;
@@ -806,20 +817,15 @@
      */
     tsx->state = PJSIP_TSX_STATE_NULL;
-    tsx->state_handler = pjsip_tsx_on_state_null;
+    tsx->state_handler = &pjsip_tsx_on_state_null;
 
     /* Get destination name from the message. */
-    if (tsx_process_route(tsx, tdata, &tsx->dest_name) != 0) {
-	pjsip_event event;
-	PJ_LOG(3,(tsx->obj_name, "Error: unable to get destination address for request"));
-	
-	event.type = PJSIP_EVENT_TRANSPORT_ERROR;
-	event.src_type = PJSIP_EVENT_TX_MSG;
-	event.src.tdata = tsx->last_tx;
-
+    status = tsx_process_route(tsx, tdata, &tsx->dest_name);
+    if (status != PJ_SUCCESS) {
 	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
 	tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, &event);
+	tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, 
+                      PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
 	unlock_tsx(tsx, &lck);
-	return -1;
+	return status;
     }
 
@@ -859,4 +865,5 @@
     pj_str_t *branch;
     pjsip_cseq_hdr *cseq;
+    pj_status_t status;
     struct tsx_lock_data lck;
 
@@ -878,6 +885,10 @@
      * create transaction key.
      */
-    pjsip_tsx_create_key(tsx->pool, &tsx->transaction_key, PJSIP_ROLE_UAS, 
-			 &tsx->method, rdata);
+    status = pjsip_tsx_create_key(tsx->pool, &tsx->transaction_key, 
+                                  PJSIP_ROLE_UAS, &tsx->method, rdata);
+    if (status != PJ_SUCCESS) {
+        unlock_tsx(tsx, &lck);
+        return status;
+    }
 
     /* Duplicate branch parameter for transaction. */
@@ -914,5 +925,6 @@
 	tsx->current_addr = 0;
 	tsx->remote_addr.count = 1;
-	tsx->remote_addr.entry[0].type = pjsip_transport_get_type(tsx->transport);
+	tsx->remote_addr.entry[0].type = 
+		pjsip_transport_get_type(tsx->transport);
 	pj_memcpy(&tsx->remote_addr.entry[0].addr, 
 		  &rdata->addr, rdata->addr_len);
@@ -924,15 +936,8 @@
 					 rdata->via, &tsx->dest_name);
 	if (status != PJ_SUCCESS) {
-	    pjsip_event event;
-	    PJ_LOG(2,(tsx->obj_name, "Unable to get destination address "
-				     "for response"));
-	    
-	    event.type = PJSIP_EVENT_TRANSPORT_ERROR;
-	    event.src_type = PJSIP_EVENT_TX_MSG;
-	    event.src.tdata = tsx->last_tx;
-
 	    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
 	    tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-	    tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, &event);
+	    tsx_set_state(tsx, PJSIP_TSX_STATE_TERMINATED, 
+                          PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
 	    unlock_tsx(tsx, &lck);
 	    return status;
@@ -944,5 +949,6 @@
 	 */
 	PJ_LOG(5,(tsx->obj_name, "tsx resolving destination %.*s:%d",
-				 tsx->dest_name.host.slen, tsx->dest_name.host.ptr,
+				 tsx->dest_name.host.slen, 
+				 tsx->dest_name.host.ptr,
 				 tsx->dest_name.port));
 
@@ -976,9 +982,12 @@
 
     PJ_LOG(5,(tsx->obj_name, "got timer event (%s timer)", 
-	     (entry->id == TSX_TIMER_RETRANSMISSION ? "Retransmit" : "Timeout")));
-
-    event.type = event.src_type = PJSIP_EVENT_TIMER;
-    event.src.timer = (entry->id == TSX_TIMER_RETRANSMISSION ? 
-	&tsx->retransmit_timer : &tsx->timeout_timer);
+	     (entry->id==TSX_TIMER_RETRANSMISSION ? "Retransmit" : "Timeout")));
+
+
+    if (entry->id == TSX_TIMER_RETRANSMISSION) {
+        PJSIP_EVENT_INIT_TIMER(event, &tsx->retransmit_timer);
+    } else {
+        PJSIP_EVENT_INIT_TIMER(event, &tsx->timeout_timer);
+    }
 
     /* Dispatch event to transaction. */
@@ -1000,8 +1009,9 @@
     pjsip_msg *msg;
     pjsip_host_port dest_addr;
-    pjsip_event event;
     pjsip_via_hdr *via;
     struct tsx_lock_data lck;
-
+    pj_status_t status = PJ_SUCCESS;
+
+    /* Lock tsx. */
     lock_tsx(tsx, &lck);
 
@@ -1024,6 +1034,6 @@
 
     /* Get destination name from the message. */
-    if (tsx_process_route(tsx, tdata, &dest_addr) != 0){
-	PJ_LOG(2,(tsx->obj_name, "Unable to get destination address for request"));
+    status = tsx_process_route(tsx, tdata, &dest_addr);
+    if (status != 0){
 	goto on_error;
     }
@@ -1089,8 +1099,7 @@
      */
     tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-    event.type = PJSIP_EVENT_TRANSPORT_ERROR;
-    event.src_type = PJSIP_EVENT_TX_MSG;
-    event.src.tdata = tdata;
-    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, &event);
+
+    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                   PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
 
     unlock_tsx(tsx, &lck);
@@ -1106,17 +1115,14 @@
     pjsip_event event;
     struct tsx_lock_data lck;
-
-    PJ_LOG(5,(tsx->obj_name, "on transmit msg (tdata=%p)", tdata));
-
-    event.type = event.src_type = PJSIP_EVENT_TX_MSG;
-    event.src.tdata = tdata;
-
-    PJ_LOG(5,(tsx->obj_name, "on state %s (ev=%s, src=%s, data=%p)", 
-	      state_str[tsx->state], pjsip_event_str(event.type), 
-	      pjsip_event_str(event.src_type), event.src.data));
+    pj_status_t status;
+
+    PJ_LOG(5,(tsx->obj_name, "Request to transmit msg on state %s (tdata=%p)",
+                             state_str[tsx->state], tdata));
+
+    PJSIP_EVENT_INIT_TX_MSG(event, tsx, tdata);
 
     /* Dispatch to transaction. */
     lock_tsx(tsx, &lck);
-    (*tsx->state_handler)(tsx, &event);
+    status = (*tsx->state_handler)(tsx, &event);
     unlock_tsx(tsx, &lck);
 }
@@ -1131,15 +1137,14 @@
     pjsip_event event;
     struct tsx_lock_data lck;
-
-    event.type = event.src_type = PJSIP_EVENT_RX_MSG;
-    event.src.rdata = rdata;
-
-    PJ_LOG(5,(tsx->obj_name, "on state %s (ev=%s, src=%s, data=%p)", 
-	      state_str[tsx->state], pjsip_event_str(event.type), 
-	      pjsip_event_str(event.src_type), event.src.data));
+    pj_status_t status;
+
+    PJ_LOG(5,(tsx->obj_name, "Incoming msg on state %s (rdata=%p)", 
+	      state_str[tsx->state], rdata));
+
+    PJSIP_EVENT_INIT_RX_MSG(event, tsx, rdata);
 
     /* Dispatch to transaction. */
     lock_tsx(tsx, &lck);
-    (*tsx->state_handler)(tsx, &event);
+    status = (*tsx->state_handler)(tsx, &event);
     unlock_tsx(tsx, &lck);
 }
@@ -1150,15 +1155,10 @@
 PJ_DEF(void) pjsip_tsx_terminate( pjsip_transaction *tsx, int code )
 {
-    pjsip_event event;
     struct tsx_lock_data lck;
 
     lock_tsx(tsx, &lck);
-
     tsx->status_code = code;
-    event.type = PJSIP_EVENT_USER;
-    event.src_type = PJSIP_EVENT_USER;
-    event.src.data = 0;
-    event.obj.tsx = tsx;
-    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, &event);
+    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                   PJSIP_EVENT_USER, NULL);
 
     unlock_tsx(tsx, &lck);
@@ -1170,12 +1170,13 @@
  * transmitted when transport connection completion callback is called.
  */
-static int tsx_send_msg( pjsip_transaction *tsx, pjsip_tx_data *tdata)
-{
-    pjsip_event event;
+static pj_status_t tsx_send_msg( pjsip_transaction *tsx, 
+                                 pjsip_tx_data *tdata)
+{
+    pj_status_t status = PJ_SUCCESS;
 
     PJ_LOG(5,(tsx->obj_name, "sending msg (tdata=%p)", tdata));
 
     if (tsx->transport_state == PJSIP_TSX_TRANSPORT_STATE_FINAL) {
-	int sent;
+	pj_ssize_t sent;
 	pjsip_event before_tx_event;
 
@@ -1200,23 +1201,20 @@
 			pjsip_transport_get_type_name(tsx->transport));
 		pj_strdup2(tdata->pool, &via->sent_by.host, 
-			pj_sockaddr_get_str_addr(addr_name));
-		via->sent_by.port = pj_sockaddr_get_port(addr_name);
+			   pj_inet_ntoa(addr_name->sin_addr));
+		via->sent_by.port = pj_ntohs(addr_name->sin_port);
 	    }
 	}
 
 	/* Notify everybody we're about to send message. */
-	before_tx_event.type = PJSIP_EVENT_BEFORE_TX;
-	before_tx_event.src_type = PJSIP_EVENT_TX_MSG;
-	before_tx_event.obj.tsx = tsx;
-	before_tx_event.src.tdata = tdata;
-	before_tx_event.data.long_data = tsx->retransmit_count;
-	pjsip_endpt_send_tsx_event( tsx->endpt, &before_tx_event  );
+        PJSIP_EVENT_INIT_PRE_TX_MSG(before_tx_event, tsx, tdata, 
+                                    tsx->retransmit_count);
+	pjsip_endpt_send_tsx_event( tsx->endpt, &before_tx_event );
 
 	tsx->has_unsent_msg = 0;
-	sent = pjsip_transport_send_msg(
-		tsx->transport, tdata,
-		&tsx->remote_addr.entry[tsx->current_addr].addr
-		);
-	if (sent < 1) {
+	status = pjsip_transport_send_msg(
+		        tsx->transport, tdata,
+		        &tsx->remote_addr.entry[tsx->current_addr].addr,
+                        &sent);
+	if (status != PJ_SUCCESS) {
 	    goto on_error;
 	}
@@ -1229,9 +1227,7 @@
 on_error:
     tsx->status_code = PJSIP_SC_TSX_TRANSPORT_ERROR;
-    event.type = PJSIP_EVENT_TRANSPORT_ERROR;
-    event.src_type = PJSIP_EVENT_TX_MSG;
-    event.src.tdata = tdata;
-    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, &event);
-    return -1;
+    tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                   PJSIP_EVENT_TRANSPORT_ERROR, (void*)status);
+    return status;
 }
 
@@ -1242,4 +1238,6 @@
 					 int should_restart_timer)
 {
+    pj_status_t status;
+
     PJ_LOG(4,(tsx->obj_name, "retransmiting (tdata=%p, count=%d, restart?=%d)", 
 	      tsx->last_tx, tsx->retransmit_count, should_restart_timer));
@@ -1249,6 +1247,7 @@
     ++tsx->retransmit_count;
 
-    if (tsx_send_msg( tsx, tsx->last_tx) != 0) {
-	return -1;
+    status = tsx_send_msg( tsx, tsx->last_tx);
+    if (status != PJ_SUCCESS) {
+	return status;
     }
     
@@ -1258,10 +1257,11 @@
 	int msec_time = (1 << (tsx->retransmit_count)) * PJSIP_T1_TIMEOUT;
 
-	if (tsx->method.id != PJSIP_INVITE_METHOD && msec_time > PJSIP_T2_TIMEOUT) 
+	if (tsx->method.id!=PJSIP_INVITE_METHOD && msec_time>PJSIP_T2_TIMEOUT) 
 	    msec_time = PJSIP_T2_TIMEOUT;
 
 	timeout.sec = msec_time / 1000;
 	timeout.msec = msec_time % 1000;
-	pjsip_endpt_schedule_timer( tsx->endpt, &tsx->retransmit_timer, &timeout);
+	pjsip_endpt_schedule_timer( tsx->endpt, &tsx->retransmit_timer, 
+				    &timeout);
     }
 
@@ -1272,6 +1272,9 @@
  * Handler for events in state Null.
  */
-static int  pjsip_tsx_on_state_null( pjsip_transaction *tsx, pjsip_event *event )
-{
+static pj_status_t pjsip_tsx_on_state_null( pjsip_transaction *tsx, 
+                                            pjsip_event *event )
+{
+    pj_status_t status;
+
     pj_assert( tsx->state == PJSIP_TSX_STATE_NULL);
     pj_assert( tsx->last_tx == NULL );
@@ -1282,8 +1285,9 @@
 	/* Set state to Trying. */
 	pj_assert(event->type == PJSIP_EVENT_RX_MSG);
-	tsx_set_state( tsx, PJSIP_TSX_STATE_TRYING, event);
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TRYING, 
+                       PJSIP_EVENT_RX_MSG, event->body.rx_msg.rdata );
 
     } else {
-	pjsip_tx_data *tdata = event->src.tdata;
+	pjsip_tx_data *tdata = event->body.tx_msg.tdata;
 
 	/* Save the message for retransmission. */
@@ -1292,6 +1296,7 @@
 
 	/* Send the message. */
-	if (tsx_send_msg( tsx, tdata) != 0) {
-	    return -1;
+        status = tsx_send_msg( tsx, tdata);
+	if (status != PJ_SUCCESS) {
+	    return status;
 	}
 
@@ -1299,5 +1304,6 @@
 	 * timeout.
 	 */
-	pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, &timeout_timer_val);
+	pjsip_endpt_schedule_timer( tsx->endpt, &tsx->timeout_timer, 
+                                    &timeout_timer_val);
 
 	/* Start Timer A (or timer E) for retransmission only if unreliable 
@@ -1307,10 +1313,12 @@
 	    PJSIP_TRANSPORT_IS_RELIABLE(tsx->transport)==0) 
 	{
-	    pjsip_endpt_schedule_timer(tsx->endpt, &tsx->retransmit_timer, &t1_timer_val);
+	    pjsip_endpt_schedule_timer(tsx->endpt, &tsx->retransmit_timer, 
+                                       &t1_timer_val);
 	    tsx->retransmit_count = 0;
 	}
 
 	/* Move state. */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_CALLING, event);
+	tsx_set_state( tsx, PJSIP_TSX_STATE_CALLING, 
+                       PJSIP_EVENT_TX_MSG, tdata);
     }
 
@@ -1322,6 +1330,6 @@
  * is received.
  */
-static int  pjsip_tsx_on_state_calling( pjsip_transaction *tsx, 
-				        pjsip_event *event)
+static pj_status_t pjsip_tsx_on_state_calling( pjsip_transaction *tsx, 
+				               pjsip_event *event )
 {
     pj_assert(tsx->state == PJSIP_TSX_STATE_CALLING);
@@ -1329,14 +1337,16 @@
 
     if (event->type == PJSIP_EVENT_TIMER && 
-	event->src.timer == &tsx->retransmit_timer) 
+	event->body.timer.entry == &tsx->retransmit_timer) 
     {
+        pj_status_t status;
 
 	/* Retransmit the request. */
-	if (pjsip_tsx_retransmit( tsx, 1 ) != 0) {
-	    return -1;
+        status = pjsip_tsx_retransmit( tsx, 1 );
+	if (status != PJ_SUCCESS) {
+	    return status;
 	}
 
     } else if (event->type == PJSIP_EVENT_TIMER && 
-	      event->src.timer == &tsx->timeout_timer) 
+	       event->body.timer.entry == &tsx->timeout_timer) 
     {
 
@@ -1350,8 +1360,9 @@
 
 	/* Inform TU. */
-	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, event );
+	tsx_set_state( tsx, PJSIP_TSX_STATE_TERMINATED, 
+                       PJSIP_EVENT_TIMER, &tsx->timeout_timer);
 
 	/* Transaction is destroyed */
-	return -1;
+	return PJSIP_ETSXDESTROYED;
 
     } else if (event->type == PJSIP_EVENT_RX_MSG) {
@@ -1370,5 +1381,5 @@
 	 */
 	/* Keep last_tx for authorization. */
-	code = event->src.rdata->msg->line.status.code;
+	code = event->body.rx_msg.rdata->msg->line.status.code;
 	if (tsx->method.id != PJSIP_INVITE_METHOD && code!=401 && code!=407) {
 	    pjsip_tx_data_dec_ref(tsx->last_tx);
@@ -1381,4 +1392,5 @@
     } else {
 	pj_assert(0);
+        return PJ_EBUG;
     }
 
@@ -1392,7 +1404,8 @@
  *	 non-INVITE client transaction (bug in RFC?).
  */
-static int  pjsip_tsx_on_state_trying( pjsip_transaction *tsx, pjsip_event *event)
-{
-    int result;
+static pj_status_t pjsip_tsx_on_state_trying( pjsip_transaction *tsx, 
+                                              pjsip_event *event)
+{
+    pj_status_t status;
 
     pj_assert(tsx->state == PJSIP_TSX_STATE_TRYING);
